from .component import uSwidComponent as uSwidComponent, uSwidComponentType as uSwidComponentType
from .container import uSwidContainer as uSwidContainer
from .entity import uSwidEntity as uSwidEntity, uSwidEntityRole as uSwidEntityRole
from .errors import NotSupportedError as NotSupportedError
from .evidence import uSwidEvidence as uSwidEvidence
from .format import uSwidFormatBase as uSwidFormatBase
from .hash import uSwidHash as uSwidHash, uSwidHashAlg as uSwidHashAlg
from .link import uSwidLink as uSwidLink, uSwidLinkRel as uSwidLinkRel
from .payload import uSwidPayload as uSwidPayload
from enum import IntEnum

class uSwidGlobalMap(IntEnum):
    TAG_ID = 0
    SOFTWARE_NAME = 1
    ENTITY = 2
    EVIDENCE = 3
    LINK = 4
    SOFTWARE_META = 5
    PAYLOAD = 6
    HASH = 7
    CORPUS = 8
    PATCH = 9
    MEDIA = 10
    SUPPLEMENTAL = 11
    TAG_VERSION = 12
    SOFTWARE_VERSION = 13
    VERSION_SCHEME = 14
    LANG = 15
    DIRECTORY = 16
    FILE = 17
    PROCESS = 18
    RESOURCE = 19
    SIZE = 20
    FILE_VERSION = 21
    KEY = 22
    LOCATION = 23
    FS_NAME = 24
    ROOT = 25
    PATH_ELEMENTS = 26
    PROCESS_NAME = 27
    PID = 28
    TYPE = 29
    ENTITY_NAME = 31
    REG_ID = 32
    ROLE = 33
    THUMBPRINT = 34
    DATE = 35
    DEVICE_ID = 36
    ARTIFACT = 37
    HREF = 38
    OWNERSHIP = 39
    REL = 40
    MEDIA_TYPE = 41
    USE = 42
    ACTIVATION_STATUS = 43
    CHANNEL_TYPE = 44
    COLLOQUIAL_VERSION = 45
    DESCRIPTION = 46
    EDITION = 47
    ENTITLEMENT_DATA_REQUIRED = 48
    ENTITLEMENT_KEY = 49
    GENERATOR = 50
    PERSISTENT_ID = 51
    PRODUCT = 52
    PRODUCT_FAMILY = 53
    REVISION = 54
    SUMMARY = 55
    UNSPSC_CODE = 56
    UNSPSC_VERSION = 57
    FIRMWARE_FIELD = 59
    FIRMWARE_MANIFEST_ID_FIELD = 63
    FIRMWARE_MANIFEST_CREATION_TIMESTAMP = 64
    FIRMWARE_MANIFEST_VERSION = 65
    FIRMWARE_MANIFEST_DESCRIPTION = 66
    FIRMWARE_MANIFEST_NONCE = 67
    FIRMWARE_MANIFEST_DEPENDENCIES = 68
    FIRMWARE_MANIFEST_ALIASES = 69
    FIRMWARE_MANIFEST_TARGET_DEVICE_ID = 85
    FIRMWARE_MANIFEST_PAYLOAD_ENTRY = 60
    FIRMWARE_PAYLOAD_ID = 61
    FIRMWARE_PAYLOAD_PACKAGE_ID = 62
    FIRMWARE_PAYLOAD_DESCRIPTION = 70
    FIRMWARE_PAYLOAD_FORMAT = 71
    FIRMWARE_PAYLOAD_FORMAT_TYPE = 72
    FIRMWARE_PAYLOAD_FORMAT_GUIDANCE = 73
    FIRMWARE_PAYLOAD_SIZE = 74
    FIRMWARE_PAYLOAD_PACKAGE = 75
    FIRMWARE_PAYLOAD_PACKAGE_COMPRESSION_TYPE = 76
    FIRMWARE_PAYLOAD_PACKAGE_COMPRESSION_GUIDANCE = 77
    FIRMWARE_PAYLOAD_PACKAGE_VALUE = 78
    FIRMWARE_PAYLOAD_TARGET_COMPONENT_INDEX = 79
    FIRMWARE_PAYLOAD_STORAGE_IDENTIFIER = 80
    FIRMWARE_PAYLOAD_TARGET_DEPENDENCY = 81
    FIRMWARE_PAYLOAD_RELATIONSHIPS = 84
    FIRMWARE_TARGET_DEVICE_IDENTIFIER_VENDOR = 86
    FIRMWARE_TARGET_DEVICE_IDENTIFIER_TYPE = 87
    FIRMWARE_TARGET_DEVICE_IDENTIFIER_MODEL = 88
    FIRMWARE_TARGET_DEVICE_IDENTIFIER_CLASS = 89
    FIRMWARE_TARGET_DEVICE_IDENTIFIER_RFC4122 = 90
    FIRMWARE_TARGET_DEVICE_IDENTIFIER_IEEE802_1_AR = 91
    FIRMWARE_PAYLOAD_TARGET_MINIMAL_VERSION = 92
    FIRMWARE_PAYLOAD_DIGESTS = 97
    FIRMWARE_PAYLOAD_DIGEST_TYPE = 98
    FIRMWARE_PAYLOAD_DIGEST_GUIDANCE = 99
    FIRMWARE_PAYLOAD_DIGEST_VALUE = 100
    FIRMWARE_PAYLOAD_CONDITIONS = 101
    FIRMWARE_PAYLOAD_DIRECTIVES = 104
    FIRMWARE_PAYLOAD_SIMPLE_VERSION = 107
    FIRMWARE_PAYLOAD_VERSION = 108
    FIRMWARE_MANIFEST_SIMPLE_EXTENSIONS = 115
    FIRMWARE_PAYLOAD_SIMPLE_EXTENSIONS = 116

class uSwidFormatCoswid(uSwidFormatBase):
    def __init__(self) -> None: ...
    def load(self, blob: bytes, path: str | None = None) -> uSwidContainer: ...
    def save(self, container: uSwidContainer) -> bytes: ...
